/*
 * Created on 2004/08/04
 * Author aki@www.xucker.jpn.org
 * License Apache2.0 or Common Public License
 */
package org.jpn.xucker.commons.util;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URL;
import java.net.URLDecoder;
import java.util.Properties;

/**
 * 
 *  
 */
public class FileProperties implements
        org.jpn.xucker.commons.util.ApplicationProperties {
    Properties properties;

    private File file;

    public FileProperties(File file) {
        this.file = file;
        properties = new Properties();
        try {
            if (file.exists()) {
                properties.load(new FileInputStream(file));
            }

        } catch (FileNotFoundException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }

    public void set(String key, int value) {
        set(key, "" + value);
    }

    public void remove(String key) {
        properties.remove(key);
    }

    public void set(String key, String value) {
        properties.put(key, value);
    }

    public String get(String key) {
        
        return properties.getProperty(key);
    }

    public String get(String key, String defaultValue) {
        return properties.getProperty(key, defaultValue);
    }

    public void save() {
        try {
            properties.save(new FileOutputStream(file), null);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static File searchFileAroundClass(String fileName) {
        ClassLoader loader = FileProperties.class.getClassLoader();
        String path = FileProperties.class.getName().replaceAll("\\.", "/");
        path = path + ".class";

        URL url = loader.getResource(path);
        String classPath=url.toString();
        
        System.out.println(classPath);
        if (classPath.startsWith("jar:")) {
            int last = classPath.lastIndexOf("!");
            classPath = classPath.substring("jar:".length(), last);
        }

        if (classPath.startsWith("file:/")) {
            String filePath=null;
            try {
                filePath=URLDecoder.decode(classPath
                        .substring("file:/".length()),"utf-8");
            } catch (UnsupportedEncodingException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
            File checkFile = new File(filePath).getParentFile();
            while (true) {
                File tmp = new File(checkFile, fileName);
                	System.out.println(tmp.getAbsolutePath());
                if (tmp.exists()) {
                    return tmp;
                }

                else {
                    checkFile = checkFile.getParentFile();
                    if (checkFile == null) {
                        break;
                    }

                }
            }
            return null;
        } else {
            return null;
        }
    }

    /**
     * @return
     */
    public String getFilePath() {
        return file.getAbsolutePath();
    }

    /**
     * @param show_normal_html
     * @return
     */
    public boolean getBoolean(String key) {
      
        String value = get(key);
        if (value != null && value.equals("true")) {
            return true;
        }
        return false;
    }

    /**
     * @param show_normal_html
     * @param selection
     */
    public void setBoolean(String key, boolean selection) {
      
        set(key, "" + selection);
    }

    /**
     * @return
     */
    public boolean exist() {
      return file.exists();
    }
}