/*
 * Created on 2004/08/15
 * Author aki@www.xucker.jpn.org
 * License Apache2.0 or Common Public License
 */
package org.jpn.xucker.linkcheck;

import java.io.File;
import java.util.Arrays;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.layout.RowData;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.jpn.xucker.commons.swt.series.ResultData;
import org.jpn.xucker.commons.swt.series.fls.FileListStandard;
import org.jpn.xucker.commons.swt.ui.FileDirChoicer;
import org.jpn.xucker.commons.swt.ui.FileStatusChangeEvent;
import org.jpn.xucker.commons.swt.ui.FileStatusChangeListener;
import org.jpn.xucker.commons.util.FileProperties;
import org.jpn.xucker.html.HtmlError;
import org.jpn.xucker.html.HtmlTester;

/**
 * 
 *  
 */
public class LinkChecker extends FileListStandard implements
        FileStatusChangeListener {

    /**
     * @param shell
     */
    Button showNormalHtmlCheckButton;

    private Button absoluteCheckButton;

    private Button relativeCheckButton;

    private Button htmlCheckButton;

    private Button imageCheckButton;

    private Button otherCheckButton;

    private Button upperCheckButton;
    private Text ignoreText;

    private FileDirChoicer absoluteDirChoicer;

    private static final String FILE_LIST = "FILE_LIST";

    private static final String SHOW_NORMAL_HTML = "SHOW_NORMAL_HTML";

    private static final String SEARCH_ABSOLUTE_PATH = "SEARCH_ABSOLUTE_PATH";

    private static final String SEARCH_RELATIVE_PATH = "SEARCH_RELATIVE_PATH";

    private static final String ABSOLUTE_DIR = "ABSOLUTE_DIR";

    private static final String SEARCH_HTML_FILE = "SEARCH_HTML_FILE";

    private static final String SEARCH_IMAGE_FILE = "SEARCH_IMAGE_FILE";

    private static final String SEARCH_OTHER_FILE = "SEARCH_OTHER_FILE";

    private static final String OTHER_FILE = "OTHER_FILE";

    private boolean isInit;

    private FileProperties filePreference;

    private HtmlTester tester;

    private static final String SEARCH_UPPER_PATH="SEARCH_UPPER_PATH";

    public LinkChecker(Shell shell) {
        super(shell);
        // TODO Auto-generated constructor stub
        HtmlTester tester = new HtmlTester();
    }

    public static void main(String[] args) {
        Display display = new Display();
        Shell shell = new Shell(display, SWT.CLOSE | SWT.MIN);

        try {
            LinkChecker main = new LinkChecker(shell);

            shell.open();

            while (!shell.isDisposed()) {
                if (!display.readAndDispatch()) {
                    display.sleep();
                }
            }
            display.dispose();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (!shell.isDisposed()) {
                shell.close();
            }

            display.dispose();
            //System.exit(0);
        }

    }

    /*
     * (non-Javadoc)
     * 
     * @see org.jpn.xucker.commons.swt.series.fls.FileListStandard#afterConstract()
     */
    protected void afterConstract() {
        // TODO Auto-generated method stub
        isInit = true;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.jpn.xucker.commons.swt.series.fls.FileListStandard#beforeConstract()
     */
    protected void beforeConstract() {
        // TODO Auto-generated method stub
        resultColumnText = new String[] { "", "URL", "t@CpX" };
        resultColumnWidth = new int[] { 230, 120, 130 };

        HOMEPAGE_URL = "http://www.xucker.jpn.org/product/linkcheck.html";
        APP_NAME = "LinkChecker";
        ICON_RESOURCE = "org/jpn/xucker/linkcheck/resource/icon.png";
        EXEC_LABEL = "ׂ";
        version = 0.2;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.jpn.xucker.commons.swt.series.fls.FileListStandard#execFile(java.io.File)
     */

    public void beforeExecute() {
        tester = new HtmlTester();
       // tester.setDebug(true);
        tester.setTestAbsolutePath(absoluteCheckButton.getSelection());
        tester.setTestHtmlFile(htmlCheckButton.getSelection());
        tester.setTestImageFile(imageCheckButton.getSelection());
        tester.setTestOtherFile(otherCheckButton.getSelection());
        tester.setTestRelativePath(relativeCheckButton.getSelection());
        tester.setTestUpperPath(upperCheckButton.getSelection());
        if (absoluteCheckButton.getSelection()
                && absoluteDirChoicer.getFile() != null) {
            tester.setRootDir(absoluteDirChoicer.getFile().getAbsolutePath());
        }
    }

    public void execFile(File file) {
        /*
        if (!absoluteCheckButton.getSelection()
                || absoluteDirChoicer.getFile() == null) {
            //System.out.println("file select");
            tester.setRootDir(file.getParent());
        }*/
        tester.doCheck(file);
    }

    public void afterExecute() {
        System.out.println("afterExecute");
        HtmlError error[] = tester.getErrors();
        for (int i = 0; i < error.length; i++) {
            ResultData data = new ResultData();
            File file = new File(error[i].getRootDir(), error[i].getBaseHref());
            data.setValue(resultColumnText[0], "t@C܂:"
                    + error[i].getLinkHref());
            data.setValue(resultColumnText[1], error[i].getBaseHref());
            data.setColor(new Color(shell.getDisplay(), 255, 0, 0));

            data.setValue(resultColumnText[2], file.getAbsolutePath());
            addResult(data);
        }

        if (showNormalHtmlCheckButton.getSelection()) {
            String checkpaths[] = tester.getCheckedFiles();
            Arrays.sort(checkpaths);
            for (int i = 0; i < checkpaths.length; i++) {
                ResultData data = new ResultData();

                String url = checkpaths[i].substring(tester.getRootDir()
                        .length());
                url = url.replaceAll("\\\\", "/");
                data.setValue(resultColumnText[1], url);
                data.setValue(resultColumnText[2], checkpaths[i]);
                data.setColor(new Color(shell.getDisplay(), 0, 0, 255));
                addResult(data);
            }
        }
        System.out.println("error");

        if (error.length == 0) {
            MessageBox box = new MessageBox(shell, SWT.OK
                    | SWT.ICON_INFORMATION);
            box.setMessage("G[͂܂ł");

            //int result=box.open();
            //never use result int,for PMD
            box.open();
        }
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.jpn.xucker.commons.swt.series.fls.FileListStandard#createOptionUI(org.eclipse.swt.widgets.Group)
     */
    protected void createOptionUI(Group optionGroup) {
        shell.setSize(500, 510);
        fileListTableRowData.height = 70;
        fileListTable.addFileListChangeListener(this);
        fileListTable.setFileExtension(new String[] { "html", "htm", "shtml" });
        optionGroup.setText("");
        RowData data = new RowData();
        data.width = 480;
        optionGroup.setLayoutData(data);

        createOptionLabel(optionGroup, "");

        showNormalHtmlCheckButton = new Button(optionGroup, SWT.CHECK);
        showNormalHtmlCheckButton.addSelectionListener(this);
        showNormalHtmlCheckButton.setText("ׂt@CURL\");

        showNormalHtmlCheckButton.setSelection(true);//default
        RowData data2 = new RowData();
        data2.width = 450;
        showNormalHtmlCheckButton.setLayoutData(data2);

        createOptionLabel(optionGroup, "ׂpX");
        absoluteCheckButton = new Button(optionGroup, SWT.CHECK);
        absoluteCheckButton.addSelectionListener(this);
        absoluteCheckButton.setText("΃pX𒲂ׂ ([gDir)");
        absoluteDirChoicer = new FileDirChoicer(optionGroup, SWT.NULL,
                FileDirChoicer.DIR, null,true);
        absoluteDirChoicer.setPathWidth(150);
        absoluteDirChoicer.addFileListChangeListener(this);
        absoluteCheckButton
        .setToolTipText("http://Ȃǂn܂OpXׂ͒܂B/n܂pX𒲂ׂ܂");
        //add
        relativeCheckButton = new Button(optionGroup, SWT.CHECK);
        relativeCheckButton.addSelectionListener(this);
        relativeCheckButton.setText("΃pX𒲂ׂ");
        relativeCheckButton.setSelection(true);//default
        
        upperCheckButton=new Button(optionGroup,SWT.CHECK);
        upperCheckButton.addSelectionListener(this);
        upperCheckButton.setText("̊Kwׂ");
        upperCheckButton.setSelection(true);//default

        createOptionLabel(optionGroup, "ׂt@C`");
        htmlCheckButton = new Button(optionGroup, SWT.CHECK);
        htmlCheckButton.addSelectionListener(this);
        htmlCheckButton.setText("html𒲂ׂ(html/htm/shtml)");
        htmlCheckButton.setSelection(true);//default
        imageCheckButton = new Button(optionGroup, SWT.CHECK);
        imageCheckButton.addSelectionListener(this);
        imageCheckButton.setText("摜𒲂ׂ(gif/png/jpg/jpeg)");
        imageCheckButton.setSelection(true);//default
        otherCheckButton = new Button(optionGroup, SWT.CHECK);
        otherCheckButton.addSelectionListener(this);
        otherCheckButton.setText("̑̃t@Cׂ");
        otherCheckButton.setSelection(true);//default
        Label l3 = new Label(optionGroup, SWT.NULL);
        l3.setText("t@Cgq");
        ignoreText = new Text(optionGroup, SWT.READ_ONLY);

        ignoreText.setText("(cgi php jsp)");

        RowData data3 = new RowData();
        data3.width = 200;
        ignoreText.setLayoutData(data3);

        loadPreference();

        statusChanged();

    }

    /**
     *  
     */
    private void loadPreference() {
        File filePath = FileProperties.searchFileAroundClass("linkcheck.exe");
        if (filePath != null) {
            filePreference = new FileProperties(new File(filePath.getParent(),
                    "linkcheck.properties"));
            if (filePreference != null && filePreference.exist()) {
                setSetting();
            }
        }
    }

    /**
     * @param filePreference
     */
    private void setSetting() {
        showNormalHtmlCheckButton.setSelection(filePreference
                .getBoolean(SHOW_NORMAL_HTML));
        this.absoluteCheckButton.setSelection(filePreference
                .getBoolean(SEARCH_ABSOLUTE_PATH));
        this.relativeCheckButton.setSelection(filePreference
                .getBoolean(SEARCH_RELATIVE_PATH));
        this.upperCheckButton.setSelection(filePreference
                .getBoolean(SEARCH_UPPER_PATH));
        fileListTable.setFileListText(filePreference.get(FILE_LIST, ""));
        String path = filePreference.get(ABSOLUTE_DIR);
        if (path != null && !path.equals("")) {
            File file = new File(path);
            absoluteDirChoicer.setFile(file);
        }

        htmlCheckButton.setSelection(filePreference
                .getBoolean(SEARCH_HTML_FILE));
        imageCheckButton.setSelection(filePreference
                .getBoolean(SEARCH_IMAGE_FILE));
        otherCheckButton.setSelection(filePreference
                .getBoolean(SEARCH_OTHER_FILE));
        //this version not support;
        //ignoreText.setText(filePreference.get(OTHER_FILE,""));

    }

    /**
     * @param optionGroup
     * @param string
     */
    private void createOptionLabel(Group optionGroup, String label) {
        Label label1 = new Label(optionGroup, SWT.NULL);
        label1.setText("y " + label + " z");
        // label1.setForeground(new
        // Color(label1.getShell().getDisplay(),64,64,64));
        RowData data1 = new RowData();
        data1.width = 450;
        label1.setLayoutData(data1);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.jpn.xucker.commons.swt.ui.FileListChangeListener#removeList(org.jpn.xucker.commons.swt.ui.FileListChangeEvent)
     */
    public void removeList(FileStatusChangeEvent event) {
        // TODO Auto-generated method stub
        propertyUpdate();
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.jpn.xucker.commons.swt.ui.FileListChangeListener#addList(org.jpn.xucker.commons.swt.ui.FileListChangeEvent)
     */
    public void addList(FileStatusChangeEvent event) {
        // TODO Auto-generated method stub
        propertyUpdate();
    }

    protected void otherWidgetSelected(SelectionEvent event) {
        // if it's needed,you should overwrite
        propertyUpdate();
    }

    /**
     *  
     */
    private synchronized void propertyUpdate() {
        // TODO Auto-generated method stub
        if (!isInit) {
            return;
        }
        if (filePreference != null) {

            filePreference.set(FILE_LIST, fileListTable.getFileListText());
            filePreference.setBoolean(SHOW_NORMAL_HTML,
                    showNormalHtmlCheckButton.getSelection());
            filePreference.setBoolean(SEARCH_ABSOLUTE_PATH, absoluteCheckButton
                    .getSelection());

            String path = "";
            if (absoluteDirChoicer.getFile() != null) {
                path = absoluteDirChoicer.getFile().getAbsolutePath();
                
            }
            filePreference.set(ABSOLUTE_DIR, path);

            filePreference.setBoolean(SEARCH_RELATIVE_PATH, relativeCheckButton
                    .getSelection());
            
            filePreference.setBoolean(SEARCH_UPPER_PATH, upperCheckButton
                    .getSelection());
            filePreference.setBoolean(SEARCH_HTML_FILE, htmlCheckButton
                    .getSelection());
            filePreference.setBoolean(SEARCH_IMAGE_FILE, imageCheckButton
                    .getSelection());
            filePreference.setBoolean(SEARCH_OTHER_FILE, otherCheckButton
                    .getSelection());
            filePreference.save();
        }
        statusChanged();
    }

    /**
     *  
     */
    private void statusChanged() {
        if (!absoluteCheckButton.getSelection()) {
            absoluteDirChoicer.setEnabled(false);
        } else {
            absoluteDirChoicer.setEnabled(true);
        }
        
        //set exec button enable.
        if(absoluteCheckButton!=null && absoluteDirChoicer!=null && execButton!=null){
        if(absoluteCheckButton.getSelection() && absoluteDirChoicer.getFile()==null){
            execButton.setEnabled(false);
        }else{
            if(fileListTable.getFiles().length==0){
                execButton.setEnabled(false);
            }else{
                execButton.setEnabled(true);
            }
           
        }
        }
    }
}