/*
 * 쐬: 2004/03/25
 * License Apache 2.0
 * ̐ꂽRg̑}ev[gύX邽
 * EBhE > ݒ > Java > R[h > R[hƃRg
 */
package org.jpn.xucker.html;

import java.io.File;
import java.util.List;
import java.util.Vector;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.Task;

/**
 * @author ak
 * License Apache 2.0
 *
 * ̐ꂽRg̑}ev[gύX邽
 * EBhE > ݒ > Java > R[h > R[hƃRg
 */
public class LinkCheckTask extends Task {
	private File rootdir;
	private String indexfile = "index.html";
	private File startFile;
	private boolean failOnError;
	private String[] ignoreExtension;
	private List ignoreExtensionList=new Vector();
	public void execute() {
		log("start");
		if (rootdir == null) {
			throw new BuildException(
				"rootDir not set" + startFile.getAbsolutePath(),
				getLocation());

		}
		if (startFile == null) {
			startFile = new File(rootdir, indexfile);
			if (!startFile.exists()) {
				throw new BuildException(
					"startFile not found " + startFile.getAbsolutePath(),
					getLocation());

			}
		}
		ignoreExtension=(String[])ignoreExtensionList.toArray(new String[ignoreExtensionList.size()]);
		HtmlTester tester = new HtmlTester();
		tester.setRootDir(rootdir.getAbsolutePath());

		if (ignoreExtension != null) {
			tester.setIgnoreExtensions(ignoreExtension);
		}
		tester.doCheck(startFile);
		HtmlError[] error = tester.getErrors();
		if (error.length > 0) {
			for (int i = 0; i < error.length; i++) {
				String message =
					error[i].getBaseHref()
						+ " not found "
						+ error[i].getLinkHref();
				log(message, Project.MSG_ERR);
			}
			if (failOnError) {
				throw new BuildException("Link Error Found", getLocation());
			}
		}
	}

	public void setIgnoreExtensions(String ignore) {
		String tmp[] = split(",", ignore);
		ignoreExtensionList=new Vector();
		for(int i=0;i<tmp.length;i++){
			ignoreExtensionList.add(tmp[i]);
		}
	}

	/**
	 * @return
	 */
	public String getIndexFile() {
		return indexfile;
	}

	/**
	 * @return
	 */
	public File getRootDir() {
		return rootdir;
	}

	/**
	 * @return
	 */
	public File getStartFile() {
		return startFile;
	}

	/**
	 * @param string
	 */
	public void setIndexFile(String string) {
		indexfile = string;
	}

	/**
	 * @param file
	 */
	public void setRootDir(File file) {
		rootdir = file;
	}

	/**
	 * @param file
	 */
	public void setStartFile(File file) {
		startFile = file;
	}

	public static String[] split(String splitW, String baseW) {
		Vector vec = new Vector(30);
		int findN = 0;
		int lastN = 0;
		int spLength = splitW.length();
		while (true) {
			lastN = baseW.indexOf(splitW, findN);
			if (lastN == -1) {
				break;
			}

			vec.addElement(baseW.substring(findN, lastN));
			findN = lastN + spLength;
		}

		//add remain
		if (findN < baseW.length()) {
			String lastW = baseW.substring(findN, baseW.length());
			vec.addElement(lastW);
		} else {
			//add empty
			if (baseW.endsWith(splitW))
				vec.addElement("");
		}

		return (String[]) vec.toArray(new String[vec.size()]);
	}

	/**
	 * @return
	 */
	public boolean isFailOnError() {
		return failOnError;
	}

	/**
	 * @param b
	 */
	public void setFailOnError(boolean b) {
		failOnError = b;
	}

	/**
	 * @return
	 */
	public File getRootdir() {
		return rootdir;
	}

	/**
	 * @param file
	 */
	public void setRootdir(File file) {
		rootdir = file;
	}

}
